import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.InputStream;
import java.io.IOException;
import java.io.OutputStream;
import javax.microedition.io.Connector;
import javax.microedition.io.HttpConnection;
import javax.microedition.lcdui.Alert;
import javax.microedition.lcdui.AlertType;
import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.Form;
import javax.microedition.lcdui.List;
import javax.microedition.lcdui.TextBox;
import javax.microedition.lcdui.TextField;
import javax.microedition.rms.RecordStore;
import javax.microedition.rms.RecordStoreException;


public class Translator implements CommandListener {

    private Alert error;
    private List lfrom,lto;
    private Command ok = new Command("Ok", Command.OK, 1);
    private Command back = new Command("Назад", Command.BACK, 2);
    private Command ok2 = new Command("Ясно", Command.OK, 1);
    private Command fromc = new Command("Перевести с", Command.SCREEN, 2);
    private Command toc = new Command("Перевести на", Command.SCREEN, 3);
    private Command edit = new Command("Редактор",Command.SCREEN,2);
    private Command clear = new Command("Очистить",Command.SCREEN,4);
    private Command set = new Command("Настроить языки",Command.SCREEN,5);
    private Form form, mesf;
    private int from = 0;
    private int to = 0;
    private String answer2;
    public static String[] default_op_ind = {"sq","en","ar","af","be","bg","cy","hu","vi","gl","nl","el","da","iw","id","ga","is","es","it","ca","zh-CN","ko","lv","lt","mk","ms","mt","de","no","fa","pl","pt","ro","ru","sr","sk","sl","sw","tl","th","tr","uk","fi","fr","hi","hr","cs","sv","et","ja"};
    public static String[] default_op_title = {"албанский","английский","арабский","африканский","белорусский","болгарский","валлийский","венгерский","вьетнамский","галисийский","голландский","греческий","датский","иврит","индонезийский","ирландский","исландский","испанский","итальянский","каталанский","китайский","корейский","латышский","литовский","македонский","малайский","мальтийский","немецкий","норвежский","персидский","польский","португальский","румынский","русский","сербский","словацкий","словенский","суахили","тагальский","тайський","турецкий","украинский","финский","французский","хинди","хорватский","чешский","шведский","эстонский","японский"};
    private String[] from_ind;
    private String[] from_title;
    private String[] to_ind;
    private String[] to_title;
    private RecordStore rs;
    private TextBox word;

    public Translator() {

        readrms();
        error = new Alert("Упс!....", "Вы не ввели слово", null, AlertType.ERROR);
        error.setTimeout(Alert.FOREVER);
        error.addCommand(ok2);
        error.setCommandListener(this);

        word = new TextBox("Перевести "+from_ind[from]+"->"+to_ind[to],"",56320,TextField.ANY);
        word.addCommand(ok);
        word.addCommand(back);
        word.addCommand(fromc);
        word.addCommand(toc);
        word.addCommand(clear);
        word.addCommand(set);
        word.setCommandListener(this);

        mesf = new Form(null);
        mesf.addCommand(ok2);
        mesf.addCommand(edit);
        mesf.setCommandListener(this);
    }

    public void start(){
        Main.disp.setCurrent(word);
    }

    public void readrms() {
        try {
            rs = RecordStore.openRecordStore("set",false);
            try {
                from = Integer.parseInt(new String(rs.getRecord(1)));
                to = Integer.parseInt(new String(rs.getRecord(2)));
            }
            catch (NumberFormatException nfe){
                from = 0;
                to = 0;
            }
            rs.closeRecordStore();
        }

        catch (RecordStoreException rse) {
            try {
                rs = RecordStore.openRecordStore("set",true);
                rs.addRecord(Integer.toString(from).getBytes(),0,Integer.toString(from).getBytes().length);
                rs.addRecord(Integer.toString(to).getBytes(),0,Integer.toString(to).getBytes().length);
                rs.closeRecordStore();
            }
            catch (RecordStoreException rse1){show(rse1.getMessage(),"Error");}
        }
        //|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

        try {
            rs = RecordStore.openRecordStore("array",false);
            ByteArrayInputStream binput = new ByteArrayInputStream(rs.getRecord(1));
            DataInputStream dinput = new DataInputStream(binput);

            try{
                int num = dinput.readInt();
                from_ind = new String[num+1];
                to_ind = new String[num];
                from_ind[0]="auto";
                for(int index = 0; index < to_ind.length; index ++) {
                    to_ind[index] = dinput.readUTF();
                    from_ind[index+1] = to_ind[index];
                }
            }
            catch (IOException ioe){}
            dinput = null;
            binput = null;
            //=============================
            binput = new ByteArrayInputStream(rs.getRecord(2));
            dinput = new DataInputStream(binput);

            try{
                int num = dinput.readInt();
                from_title = new String[num+1];
                to_title = new String[num];
                from_title[0]="Определить";
                for(int index = 0; index < to_title.length; index ++) {
                    to_title[index] = dinput.readUTF();
                    from_title[index+1] = to_title[index];
                }
            }
            catch (IOException ioe){}
            rs.closeRecordStore();
            dinput = null;
            binput = null;
        }
        //====================CREATE========================
        catch (RecordStoreException rse) {

            ByteArrayOutputStream boutput = new ByteArrayOutputStream();
            DataOutputStream doutput = new DataOutputStream(boutput);
            try{
                doutput.writeInt(default_op_ind.length);
                for(int i=0;i<default_op_ind.length;i++){
                    doutput.writeUTF(default_op_ind[i]);
                }
            }
            catch (IOException ioe){}
            byte[] data1 = boutput.toByteArray();
            boutput = null;
            doutput = null;

            boutput = new ByteArrayOutputStream();
            doutput = new DataOutputStream(boutput);
            try{
                doutput.writeInt(default_op_title.length);
                for(int i=0;i<default_op_title.length;i++){
                    doutput.writeUTF(default_op_title[i]);
                }
            }
            catch (IOException ioe){}
            byte[] data2 = boutput.toByteArray();
            boutput = null;
            doutput = null;

            try{
                rs = RecordStore.openRecordStore("array",true);
                rs.addRecord(data1,0,data1.length);
                rs.addRecord(data2,0,data2.length);
                rs.closeRecordStore();
            }
            catch (RecordStoreException rse1){}
            data1 = null; data2 = null;

            from_ind = new String[default_op_ind.length+1];
            to_ind = new String[default_op_ind.length];
            from_ind[0]="auto";
            for(int index = 0; index < to_ind.length; index ++) {
                to_ind[index] = default_op_ind[index];
                from_ind[index+1] = to_ind[index];
            }

            from_title = new String[default_op_title.length+1];
            to_title = new String[default_op_title.length];
            from_title[0]="Определить";
            for(int index = 0; index < to_title.length; index ++) {
                to_title[index] = default_op_title[index];
                from_title[index+1] = to_title[index];
            }
        }
        check();
    }



    public void refresh(){
        word.setTitle("Перевести "+from_ind[from]+"->"+to_ind[to]);
    }

    public void check(){
        if (from>from_ind.length-1){from = from_ind.length-1;}
        if (to>to_ind.length-1){to = to_ind.length-1;}
        if (from<0){from=0;}
        if (to<0){to=0;}
    }

    public void translate(final String sentence) {

        form = new Form("Подождите...");
        form.append("Переводится...");
        Main.disp.setCurrent(form);

        new Thread() {
            public void run() {
                String qq;
                if (from_ind[from].equals("uk"))qq = URICoder.encodeSequence(Main.parser.parseukr(sentence));
                else qq = URICoder.encodeSequence(sentence);

                String query = "http://translate.google.ru/translate_a/t";
                try {
                    HttpConnection net = (HttpConnection)Connector.open(query,Connector.READ_WRITE, true);
                    net.setRequestMethod(HttpConnection.POST);
                    net.setRequestProperty("Host", "translate.google.com.ua");
                    net.setRequestProperty("User-Agent", "Opera/9.64");
                    net.setRequestProperty("Referer", "translate.google.com.ua");
                    net.setRequestProperty("Content-Type", "application/x-www-form-urlencoded");
                    net.setRequestProperty("Accept", "*/*");
                    net.setRequestProperty("Proxy-Connection", "close");

                    OutputStream output = net.openOutputStream();
                    output.write(("sl=" + from_ind[from] + "&tl=" + to_ind[to] + "&client=t&text=" + qq).getBytes());
                    output.close();


                    InputStream is = net.openInputStream();

                    ByteArrayOutputStream out = new ByteArrayOutputStream();
                    byte[] buffer = new byte[512];
                    for(;;) {
                        int copy = is.read(buffer);
                        if(copy < 0) {break;}
                        else {out.write(buffer, 0, copy);}
                    }
                    is.close();
                    net.close();
                    
                    System.out.println(new String(out.toByteArray(), "UTF-8"));

                    answer2 = Main.parser.parseanswer(new String(out.toByteArray(), "UTF-8"));

                    if (from_ind[from].equals("zh-CN")&&to_ind[to].equals("ru")){answer2 = Main.parser.chinese(answer2);}
                    if (from_ind[from].equals("zh-CN")&&to_ind[to].equals("uk")){answer2 = Main.parser.chinese(answer2);}
                }
                catch (Exception e){show(e.getMessage(),"Error");}
                show(answer2,to_title[to]);
            }
        }.start();
    }

    public void show(String mes, String title) {
        mesf.setTitle(title);
        mesf.append(mes);
        Main.disp.setCurrent(mesf);
    }

    public void setfrom() {
        lfrom = new List("Перевести с",List.IMPLICIT,from_title,null);
        lfrom.addCommand(back);
        lfrom.setCommandListener(this);
        Main.disp.setCurrent(lfrom);
    }

    public void savefrom() {

        from = lfrom.getSelectedIndex();
        try {
            rs = RecordStore.openRecordStore("set",false);
            rs.setRecord(1,Integer.toString(from).getBytes(),0,Integer.toString(from).getBytes().length);
            rs.closeRecordStore();
        }
        catch (RecordStoreException rse){show(rse.getMessage(),"Error");}
        refresh();
        Main.disp.setCurrent(word);
    }

    public void setto() {
        lto = new List("Перевести на",List.IMPLICIT,to_title,null);
        lto.addCommand(back);
        lto.setCommandListener(this);
        Main.disp.setCurrent(lto);
    }

    public void saveto() {

        to = lto.getSelectedIndex();
        try {
            rs = RecordStore.openRecordStore("set",false);
            rs.setRecord(2,Integer.toString(to).getBytes(),0,Integer.toString(to).getBytes().length);
            rs.closeRecordStore();
        }
        catch (RecordStoreException rse){show(rse.getMessage(),"Error");}
        refresh();
        Main.disp.setCurrent(word);
    }


    public void commandAction(Command c,Displayable d) {

        if (d == word) {

            if (c == back) Main.menu.start();
            if (c == ok) {
                if (word.getString().equals("")) Main.disp.setCurrent(error);
                else translate((word.getString()).trim());
            }
            if (c == fromc) setfrom();
            if (c == toc)   setto();
            if (c == clear) word.setString("");
            if (c == set)   Main.settings.start();
        }

        if (c == ok2 && d == error) Main.disp.setCurrent(word);
        if (c == ok2 && d == mesf)  {mesf.deleteAll(); Main.menu.start();}

        if (c == edit && d == mesf) {
            mesf.deleteAll();
            word.setString(answer2);
            Main.disp.setCurrent(word);
        }
        if (c == List.SELECT_COMMAND && d == lfrom) savefrom();
        if (c == back && d == lfrom)        Main.disp.setCurrent(word);
        if (c==List.SELECT_COMMAND&&d==lto) saveto();
        if (c==back&&d==lto)                Main.disp.setCurrent(word);
    }
}
