/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 *
 * @author doctor
 */




import java.io.ByteArrayOutputStream;
import java.io.InputStream;

import javax.microedition.io.Connector;
import javax.microedition.io.HttpConnection;

import javax.microedition.lcdui.Alert;
import javax.microedition.lcdui.AlertType;

import javax.microedition.lcdui.Displayable;

import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;


public class VersionMonitor implements CommandListener {
    
    private Alert update;
    
    private final static Command ok = new Command("Ok", Command.OK, 1);
    private final static Command back = new Command("Назад", Command.CANCEL, 2);
    
    public VersionMonitor() {
        update = new Alert("Доступно обновление", "Доступна новая версия программы.\nЕё можно скачать с страницы http://docd.zx6.ru/proj/j2me/GTranslateTool/\nЗагрузить сейчас?", null, AlertType.INFO);
        update.setTimeout(Alert.FOREVER);
        update.addCommand(ok);
        update.addCommand(back);
    }
    
    public void check(final String current){
        new Thread() {
            public void run() {

                try {
                    HttpConnection net = (HttpConnection)Connector.open("http://docd.zx6.ru/proj/j2me/GTranslateTool/version.txt",Connector.READ, true);
                    net.setRequestMethod(HttpConnection.GET);
                    net.setRequestProperty("Accept", "*/*");
                    net.setRequestProperty("Proxy-Connection", "close");

                    if ( (net.getLength() > 0) && (net.getLength() < 10) ) {
                        
                        InputStream is = net.openInputStream();

                        ByteArrayOutputStream out = new ByteArrayOutputStream();
                        byte[] buffer = new byte[512];
                        while(true) {
                            int copy = is.read(buffer);
                            if (copy < 0) break;
                            else out.write(buffer, 0, copy);
                        }
                        is.close();
                        net.close();
                        String newversion = new String(out.toByteArray(), "UTF-8");

                        newversion = newversion.trim();
                        if (newversion != null) {
                            if( (newversion.length() > 1) && (newversion.length() < 10) ) {
                                if ( !(current.equals(newversion)) ) updateready();
                            }
                        }
                    }
                } catch (java.io.IOException ioe){ }
            }
        }.start();
    }
    
    private void updateready() {
        update.setCommandListener(this);
        Main.disp.setCurrent(update);
    }

    public void commandAction(Command c, Displayable d) {
        if (d == update) {
            if (c == ok) {
                try {
                    boolean close = Main.main.platformRequest("http://docd.zx6.ru/proj/j2me/GTranslateTool/GTranslateTool.jad");
                    Main.main.destroyApp(true);
                } catch (javax.microedition.io.ConnectionNotFoundException cnfe) {
                    Main.menu.start();
                }
            }
            if (c == back) Main.menu.start();
        }
    }
}
